local usefor = "saejima"

local k_driftboost = k_driftboost
local k_driftcharge = k_driftcharge
local k_offroad = k_offroad
local k_boostpower = k_boostpower
local TICRATE = TICRATE
local haste = (CV_FindVar("kmp_haste") and CV_FindVar("kmp_haste").value) or JUICEBOX or BLib

local PSD_atk = {
	[2] = 13*FRACUNIT/40,
	[3] = 2*FRACUNIT/5
}
local function PSD_HasteAdjust(p)	
	local pks = p.kartstuff

	if p.psdhasteadjust then
		if p.attackboostlv == 3 then
			pks[k_driftboost] = 79
		elseif p.attackboostlv == 2 then
			pks[k_driftboost] = 39
		end
		
		p.psdhasteadjust = 0
	end
end

local function PSD_OffroadImmune(p)
	local pks = p.kartstuff
	
	if pks[k_sneakertimer] > 0
	or (pks[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge > 0))
	or pks[k_invincibilitytimer] > 0
	or pks[k_hyudorotimer] > 0 then
		return true
	end
	return false
end

local function PSD_DriftBoost (p)
	local pks = p.kartstuff
	local haste = (kmp and CV_FindVar("kmp_haste").value) or JUICEBOX or BLib

	if p.PSDlastdriftcharge > pks[k_driftcharge]
	and not (p.mo.eflags & MFE_JUSTBOUNCEDWALL) then
		--print("Boost!")
		local LDC = p.PSDlastdriftcharge
		local target = K_GetKartDriftSparkValue(p)

		if (p.PSDlastbounced
		or p.speed <= 10*FRACUNIT
		or pks[k_spinouttimer]
		or pks[k_squishedtimer]
		or LDC < (target*2)
		or p.PSDlastbuttons) then
			return
		elseif LDC >= K_GetKartDriftSparkValue(p)*4 then
			p.attackboostlv = max($, 3)
			pks[k_driftboost] = 80
		elseif LDC >= K_GetKartDriftSparkValue(p)*2 then
			p.attackboostlv = max($, 2)
			pks[k_driftboost] = 40
		end
		
		if P_RandomChance(FRACUNIT/2) then
			K_PlayAttackTaunt(p.mo)
		else
			K_PlayBoostTaunt(p.mo)
		end

		
		if haste then
			--print("Adjusting for haste")
			p.psdhasteadjust = 1
		end
	end
end

local function PSD_AttackBoost(p)
	local pks = p.kartstuff

	if (pks[k_driftboost] and p.attackboostlv)
		if not pks[k_offroad]
		or (pks[k_offroad] and PSD_OffroadImmune(p)) then
			if BLib then
				BLib.SetBoost(p, "heat", PSD_atk[p.attackboostlv], PSD_atk[p.attackboostlv]*20, 0, false, false, false, false)
			else
				pks[k_speedboost] = max($, PSD_atk[p.attackboostlv])
				--pks[k_boostpower] = max($, PSD_atk[p.attackboostlv])
				pks[k_accelboost] = max($, PSD_atk[p.attackboostlv]*20)
			end
		end
	else
		if BLib then
			BLib.SetBoost(p, "heat")
		end
	end
end

local function PSD_AcroInterop(p)
	if not acrobasics then return end

	local pks = p.kartstuff

	if p.attackboostlv then
		if pks[k_sneakertimer] then
			pks[k_driftboost] = max($, pks[k_sneakertimer])
		end

		if p.trickboost then
			pks[k_driftboost] = max($, p.trickboost)
		end
	end

	if ((not p.hastricked) and p.PSDlasttrick) then
		if p.trickgrade >= 4
			p.attackboostlv = max($, 3)
			pks[k_driftboost] = max($, 80)
		elseif p.trickgrade == 3 then
			p.attackboostlv = max($, 2)
			pks[k_driftboost] = max($, 40)
		end
	end
	
end

local function PSD_AuraHandler(p)

	if not (p.mo and p.mo.valid) then return end
	if not (p.mo.skin == usefor) then return end

	if (p.kartstuff[k_driftboost] and p.attackboostlv) then
		if not p.PSDaura then
			p.PSDaura = P_SpawnGhostMobj(p.mo)
			p.PSDaura.target = p.mo
				
		end

		if p.PSDaura and p.PSDaura.valid then
			if p.attackboostlv == 3 then
				p.PSDaura.color = SKINCOLOR_RUBY
			else
				p.PSDaura.color = SKINCOLOR_CYAN
			end
			
			p.PSDaura.frame = p.mo.frame|FF_TRANS50
			p.PSDaura.angle = p.frameangle
			p.PSDaura.destscale = (5*p.mo.scale)/4
			p.PSDaura.fuse = p.kartstuff[k_driftboost]
			P_MoveOrigin(p.PSDaura, p.mo.x, p.mo.y, p.mo.z)
			p.PSDaura.colorized = true

		end

	end

end

local function PSD_Handler(p)
	if p.spectator then return end
	if not (p.mo.skin == usefor) then return end
	if FZeroKart and FZeroKart.Active.value then return end
	local pks = p.kartstuff

	PSD_HasteAdjust(p)
	PSD_DriftBoost(p)
	PSD_AcroInterop(p)
	PSD_AttackBoost(p)
	
	--if pks[k_driftboost] then
		--print(pks[k_driftboost])
	--end
	
	if not pks[k_driftboost]
	and p.attackboostlv then
		p.attackboostlv = 0
		P_KillMobj(p.PSDaura)
		p.PSDaura = nil
	end

	p.PSDlastdriftcharge = pks[k_driftcharge]
	p.PSDlastbuttons = p.cmd.buttons & BT_DRIFT
	p.PSDlastbounced = p.mo.eflags & MFE_JUSTBOUNCEDWALL
	p.PSDlasttrick = p.hastricked
end

addHook("PlayerThink", PSD_Handler)

addHook("PostThinkFrame", function()
	if FZeroKart and FZeroKart.Active.value then return end
	for p in players.iterate
		if not ((p.mo and p.mo.valid) and p.mo.skin == usefor) then continue end
		
		PSD_AuraHandler(p)
	end

end)

local function BikeSpark(mo)
	if FZeroKart and FZeroKart.Active.value then return end
	if not (mo and mo.valid) then return end
	if not ((mo.target and mo.target.valid and mo.target.player) and (mo.target.skin == usefor)) then return end
	local p = mo.target.player
	local pks = p.kartstuff
	
	if pks[k_driftcharge] >= (K_GetKartDriftSparkValue(p)*4) then
		mo.color = SKINCOLOR_RUBY
	elseif pks[k_driftcharge] >= (K_GetKartDriftSparkValue(p)*2) then
		mo.color = SKINCOLOR_CYAN
	elseif pks[k_driftcharge] >= K_GetKartDriftSparkValue(p) then
		mo.color = SKINCOLOR_WHITE
	end
end
addHook("MobjThinker", BikeSpark, MT_DRIFTSPARK)

local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local function shouldHurt(p)
	return not (p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
		or p.kartstuff[k_invincibilitytimer] > 0 or (p.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p.hugequest.huge > 0)) or p.kartstuff[k_hyudorotimer] > 0 
		or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)))
end

local function PSD_PowerTackle(mo, mo2)
	if FZeroKart and FZeroKart.Active.value then return end
	if not (mo and mo.valid and mo.player) then return end
	if not (mo2 and mo2.valid and mo2.player) then return end
	if not (mo.skin == usefor) then return end
	local p = mo.player
	
	if ((mo.z <= mo2.z + mo2.height) and (mo.z + mo.height >= mo2.z))
	and p.attackboostlv then
		if shouldHurt(mo2.player) then
			if p.attackboostlv == 3 then
				--print("Run them pockets ho")
				K_StealBumper(p, mo2.player)
			end
			--print("ATK LV: "..p.attackboostlv)
			if ((mo2.skin == usefor) and mo2.player.attackboostlv >= p.attackboostlv) then -- Either tie, or get FUCKED.
				return
			end
			P_DamageMobj(mo2, mo, mo)
	
			if (hitfeed) 
			and not p.kartstuff[k_sneakertimer] then
				local icon = "K_HMSHOE"
				local source = generateHFForPlayer(p)
				local victim = generateHFForPlayer(mo2.player)
				
				HF_SendHitMessage(source, victim, icon)
			end
		end
	end
	return
end
addHook("MobjCollide", PSD_PowerTackle, MT_PLAYER)
addHook("MobjMoveCollide", PSD_PowerTackle, MT_PLAYER)


local function PSD_Init(p)
	p.PSDlastdriftcharge = 0
	p.PSDlastbuttons = 0
	p.PSDlastbounced = 0
	p.PSDaura = nil
	p.attackboostlv = 0
	p.PSDlasttrick = false
end
addHook("PlayerSpawn", PSD_Init)